unit FormMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus   , Jpeg;

type
  TPointWithRange=class;
  TPointLogFile=class;

  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    MnuFile: TMenuItem;
    MnuOpen: TMenuItem;
    MnuClose: TMenuItem;
    MnuLog: TMenuItem;
    MnuSet: TMenuItem;
    MnuCrossColor: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure MnuCloseClick(Sender: TObject);
    procedure MnuOpenClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure MnuLogClick(Sender: TObject);
    procedure MnuCrossColorClick(Sender: TObject);
  private
    { Private 錾 }
    OriginalImage, ZoomImage, HiddenImage:TBitmap;
    ViewPoint:TPointWithRange;
    RectAllImage:TRect;
    LogFile:TPointLogFile;
    CrossColor:TColor;
    procedure ViewPointChange(Sender:TObject;X,Y:Integer);
    procedure MakeZoomImage;
    procedure DrawCross;
    procedure ChangeRectAllImage;
    procedure Draw;
  public
    { Public 錾 }
  end;

  TOnPointChange=procedure(Sender:TObject;X,Y:Integer) of object;
  { TPointWithRangeNX
      ͈͕t2W
    property X:Integer
      XWl
      X[0,XMain]͈̔͂Ƃ
      l0
    property Y:Integer
      YWl
      Y[0,YMain]͈̔͂Ƃ
      l0
    property XNain:Integer
      XW̍ől
      l10
    property YMain:Integer
      YW̍ől
      l10}
  TPointWithRange=class(TObject)
  private
    FX,FY:Integer;
    FXMax,FYMax:Integer;
    FOnPointChange:TOnPOintChange;
    procedure SetX(value:Integer);
    procedure SetY(value:Integer);
    procedure SetXMax(value:Integer);
    procedure SetYMax(value:Integer);
  public
    constructor Create;
    property X:Integer read FX write SetX;
    property Y:Integer read FY write SetY;
    property XMax:Integer read FXMax write SetXMax;
    property YMax:Integer read FYMax write SetYMax;
    property OnPointChange:TOnPointChange read FOnPointChange write FOnPointChange;
  end;

  { TPointLogFileNX
      2W̃OƂNX
    constructor Create(const FileName:string)
      FileNameƂÕOt@CɃOo͂CX^Xmۂ
    procedure Log(APoint:TPointWithRange)
      APointXW,YWOt@Cɏ
      "XW,YW" }
  TPointLogFile=class(TObject)
  private
    FileStream:TFileStream;
  public
    constructor Create(const FileName:string);
    destructor Destroy; override;
    procedure Log(APoint:TPointWithRange);
  end;

{ funtion BestRect(ClientWidth,ClientHeight,OriginalWidth,OriginalHeight:Integer):Rect
  ClientWidth(),ClientHeight()ŕ\̈
  OriginalWidth(),ClientHeight()ŕ\̂`悷ꍇ
  ƂœKȕ`,̈Rect^ŕԂ }
function BestRect(ClientWidth,ClientHeight,OriginalWidth,OriginalHeight:Integer):TRect;

var
  Form1: TForm1;

implementation

const
  ZoomRest   = 10;
  ZoomWidth  =320;
  ZoomCenter =160;
  ZoomPixels = 20;
  labelHeight= 20;
  labelRest  =  2;
  minAllWidth=300;


// { 摜邽߂̍\̋yєz }
// type
//   T32BitColor = packed record
//     R,G,B,Alpha:Byte;
//   end;
// const
//   Max32BitColorArray = MaxInt div Sizeof(T32BitColor);
// type
//   T32BitColorArray = array [0..Max32BitColorArray-1] of T32BitColor;
//   P32BitColorArray = ^T32BitColorArray;

{$R *.dfm}
{ TForm1 }
  procedure TForm1.FormCreate(Sender: TObject);
  begin
    { g摜ZoomImagȅ }
    Self.ZoomImage:=TBitmap.Create;
    with Self.ZoomImage do
    begin
      Width :=ZoomWidth;
      Height:=ZoomWidth;
      PixelFormat:=pf32bit;
    end;
    { ̉摜OriginalImagȅ }
    Self.OriginalImage:=TBitmap.Create;
    Self.OriginalImage.PixelFormat:=pf32bit;
    { ItXN[摜̏ }
    Self.HiddenImage:=TBitmap.Create;
    Self.HiddenImage.Width:=Self.Width;
    Self.HiddenImage.Height:=Self.Height;
    { ViewPoint̏ }
    Self.ViewPoint:=TPointWithRange.Create;
    Self.ViewPoint.OnPointChange:=Self.ViewPointChange;
    Self.ViewPoint.XMax:=0;
    Self.ViewPoint.YMax:=0;
    Self.Width:=Self.Width-Self.ClientWidth+minAllWidth+ZoomRest*2+ZoomWidth;
    Self.Height:=Self.Height-Self.ClientHeight+ZoomRest*2+ZoomWidth;
    { \J[\̐F̏ }
    Self.CrossColor:=clBlue;
    { Ot@C쐬 }
    Self.LogFile:=TPointLogFile.Create(ChangeFileExt(ParamStr(0),'.log'));
  end;

  procedure TForm1.FormDestroy(Sender: TObject);
  begin
    Self.ZoomImage.Free;
    Self.ZoomImage:=nil;
    Self.OriginalImage.Free;
    Self.OriginalImage:=nil;
    Self.HiddenImage.Free;
    Self.HiddenImage:=nil;
    Self.ViewPoint.Free;
    Self.ViewPoint:=nil;
    Self.LogFile.Free;
    Self.LogFile:=nil;
  end;

  procedure TForm1.FormResize(Sender: TObject);
  begin
    if Self.ClientWidth < minAllWidth+ZoomRest*2+ZoomWidth then
    begin
      Self.Width:=Self.Width-Self.ClientWidth+minAllWidth+ZoomRest*2+ZoomWidth;
    end;
    if Self.ClientHeight < ZoomRest*2+ZoomWidth then
    begin
      Self.Height:=Self.Height-Self.ClientHeight+ZoomRest*2+ZoomWidth;
    end;
    { S̉摜̕`̈̐ݒ }
    Self.ChangeRectAllImage;
    Self.Invalidate;
  end;

  procedure TForm1.FormPaint(Sender: TObject);
  begin
    { tH[ɃItXN[摜` }
    Self.Canvas.Draw(0,0,Self.HiddenImage);
  end;

  procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
    Shift: TShiftState; X, Y: Integer);
  begin
    if not(Self.OriginalImage.Empty) and (Button = mbLeft) then
    begin
      if (X <= Self.RectAllImage.Right) and (Y <= Self.RectAllImage.Bottom) then
      begin
        { \Ă摜}EX̉E{^ŉƂ }
        Self.ViewPoint.X := Trunc(X/Self.RectAllImage.Right *Self.OriginalImage.Width);
        Self.ViewPoint.Y := Trunc(Y/Self.RectAllImage.Bottom*Self.OriginalImage.Height);
      end
      else if (X>=Self.ClientWidth-ZoomRest-ZoomWidth) and (X<Self.ClientWidth-ZoomRest) and (Y>=ZoomRest) and (Y<ZoomWidth+ZoomRest) then
      begin
        { \Ăg摜}EX̉E{^ŉƂ }
        Self.ViewPoint.X:=(X-Self.ClientWidth+ZoomRest+ZoomCenter) div 16 +Self.ViewPoint.X;
        Self.ViewPoint.Y:=(Y-ZoomRest-ZoomCenter) div 16 +Self.ViewPoint.Y;
      end;
    end;
  end;

  procedure TForm1.ViewPointChange(Sender:TObject;X,Y:Integer);
  begin
    { g摜̍XV }
    Self.MakeZoomImage;
    { ItXN[摜̕` }
    Self.Draw;
    Self.Invalidate;
  end;

  procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
    Shift: TShiftState);
  begin
    { }EX̃{^AltL[ĂĂ
      Ă邱Ƃ𖳎 }
    if ssShift in Shift then
    begin
      { ShiftL[Ă
        ɑ̃L[Ăꍇ,ꂪD悷 }
      case key of
        VK_UP   :Self.ViewPoint.Y:=Self.ViewPoint.Y-3;
        VK_DOWN :Self.ViewPoint.Y:=Self.ViewPoint.Y+3;
        VK_LEFT :Self.ViewPoint.X:=Self.ViewPoint.X-3;
        VK_RIGHT:Self.ViewPoint.X:=Self.ViewPoint.X+3;
      end;
    end
    else if ssCtrl in Shift then
    begin
      { CtrlL[Ă
        ShiftL[ȊȎ̃L[Ăꍇ,ꂪD悷 }
      case key of
        VK_UP   :Self.ViewPoint.Y:=Self.ViewPoint.Y-10;
        VK_DOWN :Self.ViewPoint.Y:=Self.ViewPoint.Y+10;
        VK_LEFT :Self.ViewPoint.X:=Self.ViewPoint.X-10;
        VK_RIGHT:Self.ViewPoint.X:=Self.ViewPoint.X+10;
      end;
    end
    else
    begin
      { ĂȂ }
      case key of
        VK_UP   :Self.ViewPoint.Y:=Self.ViewPoint.Y-1;
        VK_DOWN :Self.ViewPoint.Y:=Self.ViewPoint.Y+1;
        VK_LEFT :Self.ViewPoint.X:=Self.ViewPoint.X-1;
        VK_RIGHT:Self.ViewPoint.X:=Self.ViewPoint.X+1;
      end;
    end;
  end;

  procedure TForm1.MakeZoomImage;
  var
    { ̉摜̊g傷镔̐FꎞIɕێ }
//    OColor:array[0 .. ZoomPixels-1] of array[0 .. ZoomPixels-1] of T32BitColor;
    OColor:array[0 .. ZoomPixels-1] of array[0 .. ZoomPixels-1] of TColor;
//    Brack:T32BitColor;
//    OLIne,ZLine:P32BitColorArray;
    i,j,X,Y:Integer;
  begin
    { ̊m }
//    with Brack do
//    begin
//      R:=0;
//      G:=0;
//      B:=0;
//      Alpha:=0;
//    end;

    { g傷镔mۂ }
    for i:=0 to ZoomPixels-1 do
    begin
      Y:=i+Self.ViewPoint.Y-10;
      if (Y >= 0) and ( Y < Self.ViewPoint.YMax) then
      begin
        { Y͉摜̒ }
//        OLine:=Self.OriginalImage.ScanLine[Y];
        for j:=0 to ZoomPixels-1 do
        begin
          X:=j+Self.ViewPoint.X-10;
          if (X >= 0) and (X < Self.ViewPoint.XMax) then
          begin
            { X͉摜̒ }
//            OColor[j,i]:=OLine^[X];
            OColor[j,i]:=Self.OriginalImage.Canvas.Pixels[X,Y]
          end
          else
          begin
            { X͉摜̊O }
//            OColor[j,i]:=Brack;
            OColor[j,i]:=0;
          end;
        end;
      end
      else
      begin
        { Y͉摜̊O }
        for j:=0 to 19 do
        begin
//          OColor[j,i]:=Brack;
          OColor[j,i]:=0;
        end;
      end;
    end;
    { g債摜`悷 }
    for i:=0 to ZoomWidth-1 do
    begin
//      ZLine:=Self.ZoomImage.ScanLine[i];
      for j:=0 to ZoomWidth-1 do
      begin
        if ((j >= ZoomCenter-2) and (j <= ZoomCenter+1)) or ((i >= ZoomCenter-2) and (i <= ZoomCenter+1)) then
        begin
          { \̃J[\ }
//          ZLine^[j]:=Brack;
          Self.ZoomImage.Canvas.Pixels[j,i]:=0;
        end
        else
        begin
//          ZLine^[j]:=OColor[Trunc(j/16),Trunc(i/16)];
          Self.ZoomImage.Canvas.Pixels[j,i]:=OColor[Trunc(j/16),Trunc(i/16)];
        end;
      end;
    end;
  end;

  procedure TForm1.DrawCross;
  const
    CrossLength=10;
  var
    X,Y:Integer;
  begin
    if not(Self.OriginalImage.Empty) then
    begin
      Self.HiddenImage.Canvas.Pen.Color:=Self.CrossColor;
      X:=Trunc(Self.ViewPoint.X/Self.OriginalImage.Width*Self.RectAllImage.Right);
      Y:=Trunc(Self.ViewPoint.Y/Self.OriginalImage.Height*Self.RectAllImage.Bottom);
      Self.HiddenImage.Canvas.MoveTo(X-CrossLength,Y);
      Self.HiddenImage.Canvas.LineTo(X+CrossLength,Y);
      Self.HiddenImage.Canvas.MoveTo(X,Y-CrossLength);
      Self.HiddenImage.Canvas.LineTo(X,Y+CrossLength);
    end;
  end;

  procedure TForm1.ChangeRectAllImage;
  begin
    if Assigned(Self.OriginalImage) then
    begin
      if not(Self.OriginalImage.Empty) then
      begin
        Self.RectAllImage:=BestRect(Self.ClientWidth-ZoomRest*2-ZoomWidth,Self.ClientHeight-labelHeight,Self.OriginalImage.Width,Self.OriginalImage.Height);
      end;
    end;
    if Assigned(Self.HiddenImage) then
    begin
      { ItXN[摜̐ݒ }
      Self.HiddenImage.Width:=Self.Width;
      Self.HiddenImage.Height:=Self.Height;
      { ItXN[摜̕` }
      Self.Draw;
    end;
  end;

  procedure TForm1.Draw;
  begin
    { uV̐ݒ }
    Self.HiddenImage.Canvas.Brush:=Self.Canvas.Brush;
    { wihԂ }
    Self.HiddenImage.Canvas.FillRect(Self.ClientRect);
    { Ŝ̉摜` }
    Self.HiddenImage.Canvas.StretchDraw(Self.RectAllImage,Self.OriginalImage);
    { g摜` }
    Self.HiddenImage.Canvas.Draw(Self.ClientWidth-ZoomRest-ZoomWidth,ZoomRest,Self.ZoomImage);
    { W }
    Self.HiddenImage.Canvas.TextOut(0,Self.ClientHeight-labelHeight+labelRest,Format(' X : %d , Y : %d',[Self.ViewPoint.X,Self.ViewPoint.Y]));
    { \̃J[\` }
    Self.DrawCross;
  end;

  procedure TForm1.MnuOpenClick(Sender: TObject);
  var
    OpenDialog:TOpenDialog;
    JPEGImage:TJPEGImage;
    FileName,Ext:string;
  begin
    OpenDialog:=TOpenDialog.Create(Self);
    try
      OpenDialog.Title:='J';
      OpenDialog.Filter:='摜|*.bmp;*.jpeg;*.jpg';
      if OpenDialog.Execute then
      begin
        FileName:=OpenDialog.FileName;
        Ext:=LowerCase(ExtractFileExt(FileName));
        if Ext='.bmp' then
        begin
          { rbg}bvȂ炻̂܂ܓǂݍ }
          Self.OriginalImage.LoadFromFile(FileName);
        end
        else
        begin
          { JPEGȂǂݍŃrbg}bv }
          JPEGImage:=TJPEGImage.Create;
          try
            JPEGImage.LoadFromFile(FileName);
            Self.OriginalImage.Assign(JPEGImage);
          finally
            JPEGImage.Free;
            JPEGImage:=nil;
          end;
        end;
        { tH[^CgɃt@Ct }
        Self.Caption:=Format('Zahyou-%s',[FileName]);
        { ViewPoint̏ }
        Self.ViewPoint.XMax:=Self.OriginalImage.Width;
        Self.ViewPoint.YMax:=Self.OriginalImage.Height;
        { g摜̍XV }
        Self.MakeZoomImage;
        { S̉摜̕`̈̐ݒ }
        Self.ChangeRectAllImage;
        Self.Invalidate;
      end;
    finally
      OpenDialog.Free;
      OpenDialog:=nil;
    end;
  end;

  procedure TForm1.MnuLogClick(Sender: TObject);
  begin
    Self.LogFile.Log(Self.ViewPoint);
  end;

  procedure TForm1.MnuCloseClick(Sender: TObject);
  begin
    Self.Close;
  end;

  procedure TForm1.MnuCrossColorClick(Sender: TObject);
  var
    ColorDialog:TColorDialog;
  begin
    ColorDialog:=TColorDialog.Create(Self);
    try
      if ColorDialog.Execute then
      begin
        Self.CrossColor:=ColorDialog.Color;
        Self.DrawCross;
        Invalidate;
      end;
    finally
      ColorDialog.Free;
      ColorDialog:=nil;
    end;
  end;

{ TPointWithRange }
  constructor TPointWithRange.Create;
  begin
    Self.FX:=0;
    Self.FY:=0;
    Self.FXMax:=10;
    Self.FYMax:=10;
  end;

  procedure TPointWithRange.SetX(value:Integer);
  begin
    if (value >= 0) and (value <= Self.FXMax) then
    begin
      Self.FX:=value;
      if Assigned(Self.FOnPointChange) then
      begin
        Self.FOnPointChange(Self,Self.FX,Self.FY);
      end;
    end;
  end;

  procedure TPointWithRange.SetY(value:Integer);
  begin
    if (value >= 0) and (value <= Self.FYMax) then
    begin
      Self.FY:=value;
      if Assigned(Self.FOnPointChange) then
      begin
        Self.FOnPointChange(Self,Self.FX,Self.FY);
      end;
    end;
  end;

  procedure TPointWithRange.SetXMax(value:Integer);
  begin
    if value >= 0 then
    begin
      Self.FXMax:=value;
      if Self.FX > value then
      begin
        Self.FX:=value;
      end;
    end;
  end;

  procedure TPointWithRange.SetYMax(value:Integer);
  begin
    if value >= 0 then
    begin
      Self.FYMax:=value;
      if Self.FY > value then
      begin
        Self.FY:=value;
      end;
    end;
  end;

{ TPointLog }
  constructor TPointLogFile.Create(const FileName:string);
  begin
    Self.FileStream:=TFileStream.Create(FileName,fmCreate);
  end;

  destructor TPointLogFile.Destroy;
  begin
    Self.FileStream.Free;
    Self.FileStream:=nil;
  end;

  procedure TPointLogFile.Log(APoint:TPointWithRange);
  var
    S:string;
    B:Byte;
  begin
    S:=Format('%d,%d' ,[APoint.X,APoint.Y]);
    Self.FileStream.Write(Pointer(S)^,Length(S));
    B:=$0D;
    Self.FileStream.Write(B,1);
    B:=$0A;
    Self.FileStream.Write(B,1);
  end;

{ BestRect }
function BestRect(ClientWidth,ClientHeight,OriginalWidth,OriginalHeight:Integer):TRect;
begin
  with Result do
  begin
    Left:=0;
    Top :=0;
  end;
  if ClientWIdth*OriginalHeight > ClientHeight*OriginalWidth then
  begin
    { `悷ꍇɉ̗̈]点ׂ }
    with Result do
    begin
      Right:=Trunc(ClientHeight*OriginalWidth/OriginalHeight);
      Bottom:=ClientHeight;
    end;
  end
  else
  begin
    { `悷ꍇɏc̗̈]点ׂ }
    with Result do
    begin
      Right:=ClientWidth;
      Bottom:=Trunc(ClientWidth*OriginalHeight/OriginalWidth);
    end;
  end;
end;

end.
